package com.nemo.vidmate.download.service;
import com.nemo.vidmate.download.VideoTask;
import com.nemo.vidmate.download.service.IDownloadCallback;
import com.nemo.vidmate.download.bt.core.Torrent;
import com.nemo.vidmate.download.bt.core.stateparcel.TorrentStateParcel;

interface IDownloadInf
{
	oneway void registerCallback(IDownloadCallback cb);
    oneway void unregisterCallback(IDownloadCallback cb);

	void getTaskList(out List<VideoTask> taskList,boolean isDone);
	
	VideoTask getTaskListEx(int index ,boolean isDone);
	
	oneway void saveTask(in VideoTask vTask);
	oneway void pauseTask(in VideoTask vTask);
	oneway void continueTask(in VideoTask vTask,boolean redownload);
	long addTask(in VideoTask vTask);
	oneway void pauseAll();
	oneway void resumeAll();
		
	oneway void deleteTasks(in VideoTask vTask,boolean isDeleteFile);
	boolean updateTask(in VideoTask vTask);
	
	oneway void updataRuntime(String key,String val);
	
	oneway void sendActoinX(in List<String> action);
	
	long addFinishTask(in VideoTask vTask);
	boolean isCanNext();

	oneway void addTorrentTask(in Torrent torrent);
	oneway void pauseTorrentTask(in String id);
	oneway void resumeTorrentTask(in String id);
	oneway void deleteTorrentTask(in String id, boolean withFiles);
	oneway void startTorrentEngine();

	List<TorrentStateParcel> getTorrentList(boolean isDone);

	oneway void setShowNotify(boolean show);
}


